! UIMX ascii 2.5 key: 8562                                                      

*topLevelShell1.class: topLevelShell
*topLevelShell1.gbldecl: #include <stdio.h>\
#include <sys/ioctl.h>\
#include <errno.h>\
#include <sys/types.h>\
#include <sys/socket.h>\
#include <sys/time.h>\
#include <fcntl.h>\
#include <signal.h>\
#include <termio.h>\
#include <unistd.h>\
\
#ifdef VT\
#include <Xm/Separator.h>\
#include <Xm/Label.h>\
#include <Vt.h>\
Widget    vt1 = NULL;\
#endif\
\
#define COMMAND               ( "/bin/ksh" )\
#define  ENVFLAG     ( "-e" )\
#define  PRGFLAG     ( "-x" )\
#define  KSH         ( "ksh" )\
#define  NOUID       ( -1 )\
#define  NOGID       ( -1 )\
\
FILE *incmd = NULL;\
int pid = 0;\
char ttyline[BUFSIZ];\
\
extern swidget help_msg;\
swidget create_help_msg();\
extern swidget softkeyform;\
swidget create_softkeyform();\
void popup_help_msg();\
void popup_softkeyform();\
void addutmp();\
void delutmp();\
void getuser();\
\
\
extern int global_argc;\
extern char **global_argv;
*topLevelShell1.ispecdecl:
*topLevelShell1.funcdecl: swidget create_topLevelShell1()\

*topLevelShell1.funcname: create_topLevelShell1
*topLevelShell1.funcdef: "swidget", "<create_topLevelShell1>(%)"
*topLevelShell1.icode:
*topLevelShell1.fcode: {\
#ifdef VT\
    char environ[BUFSIZ];\
    char prog[BUFSIZ];\
    char path[BUFSIZ];\
    char *args[10];\
    int  argcnt = 0;\
    int  ttyfd = 0;\
    int  ptyfd = 0;\
    int  ruid = 0;\
    int  rgid = 0;\
    short  menuheight = 0;\
    char username[BUFSIZ];\
\
    int inx = 0;\
    for (inx = 0; inx < global_argc; inx++)\
    {\
         printf ("argv[%d] = %s\n", inx, global_argv[inx]);\
    }\
    \
    XtVaGetValues(  menu1, XmNheight, &menuheight, NULL);\
    vt1 = XtVaCreateManagedWidget( "vt1",\
		    xmVtWidgetClass, form1,\
		    XmNbottomOffset, 10,\
		    XmNbottomAttachment, XmATTACH_FORM,\
		    XmNtopOffset, 10,\
		    XmNtopAttachment, XmATTACH_WIDGET,\
		    XmNtopWidget, UxGetWidget( menu1 ),\
		    XmNrightOffset, 10,\
		    XmNrightAttachment, XmATTACH_FORM,\
		    XmNleftOffset, 10,\
		    XmNleftAttachment, XmATTACH_FORM,\
		    XmNheight, 460,\
		    XmNwidth, 740,\
		    XmNy, 30,\
		    XmNx, 40,\
		    XmNapplication, "bterm",\
		    NULL );\
\
    XmVtSyncSize( topLevelShell1, vt1, 10+menuheight, 10, 10, 10 );\
\
    XtAddCallback( vt1, XmNadjustCallback,\
		    adjustCB_vt1,\
		    (XtPointer) NULL );\
    XtAddCallback( vt1, XmNmonitorCallback,\
		    monitorCB_vt1,\
		    (XtPointer) NULL );\
\
    XtAddCallback( vt1, XmNmessageCallback,\
		    messageCB_vt1,\
		    (XtPointer) NULL );\
\
\
    strcpy( path, COMMAND );\
    args[0] = "-ksh";\
    args[1] = NULL;\
    ruid = getuid();\
    rgid = getgid();\
    getuser (username);\
    \
    incmd = procopen( path, args, ruid, rgid, &pid, &ttyfd, &ptyfd  );\
    strcpy (ttyline, ttyname(ttyfd)+5);\
    addutmp (username, ttyline, pid);\
\
    XmVtMonitor( vt1, ptyfd, pid );\
#endif\
    create_help_msg( topLevelShell1);\
    create_softkeyform (topLevelShell1);\
    return(rtrn);\
}\
\

*topLevelShell1.auxdecl: #ifdef VT\
static void	adjustCB_vt1( UxWidget, UxClientData, UxCallbackArg )\
	Widget		UxWidget;\
	XtPointer	UxClientData, UxCallbackArg;\
{\
\
    short  menuheight = 0;\
    XtVaGetValues( UxGetWidget( menu1 ), XmNheight, &menuheight, NULL);\
    XmVtSyncSize( topLevelShell1, vt1, 10+menuheight, 10, 10, 10 );\
}\
static void	monitorCB_vt1( UxWidget, UxClientData, UxCallbackArg )\
	Widget		UxWidget;\
	XtPointer	UxClientData, UxCallbackArg;\
{\
    delutmp ();\
    exit( 0 );\
}\
\
static void	messageCB_vt1( UxWidget, UxClientData, UxCallbackArg )\
	Widget		UxWidget;\
	XtPointer	UxClientData, UxCallbackArg;\
{\
    XmVtCallbackStruct *info = ( XmVtCallbackStruct * )UxCallbackArg;\
    XtVaSetValues( topLevelShell1, XmNtitle, info->data_buffer, NULL );\
    XtVaSetValues( topLevelShell1, XmNiconName, info->data_buffer, NULL );\
}\
\
static void	activateCB_my_menu2_p1_b1( UxWidget, UxClientData, UxCallbackArg )\
	Widget		UxWidget;\
	XtPointer	UxClientData, UxCallbackArg;\
{\
    char cls[BUFSIZ];\
    sprintf( cls, "%c[H%c[2J", 27, 27 );\
    XmVtWrite( vt1, cls, 7 );\
}\
\
XtEventHandler BtermMenuPost( wgt, client_data, event, ctd )\
	Widget		wgt;\
	XtPointer	client_data;\
	XEvent		*event;\
	Boolean		*ctd;\
{\
	Widget	menu = (Widget) client_data;\
	int 	which_button;\
\
	XtVaGetValues( menu, XmNwhichButton, &which_button, NULL );\
\
	if ( event->xbutton.button == which_button )\
	{\
		XmMenuPosition( menu, event );\
		XtManageChild( menu );\
	}\
}\
\
void data_input (input_str)\
char *input_str;\
{\
    if (input_str[0] == '?') input_str[0] = 27;\
    XmVtSend( vt1, input_str);\
}\
#endif
*topLevelShell1.static: true
*topLevelShell1.name: topLevelShell1
*topLevelShell1.parent: NO_PARENT
*topLevelShell1.x: 0
*topLevelShell1.y: 0
*topLevelShell1.width: 889
*topLevelShell1.height: 577
*topLevelShell1.iconName: "bterm"
*topLevelShell1.title: "bterm"
*topLevelShell1.allowShellResize: "true"

*form1.class: form
*form1.static: true
*form1.name: form1
*form1.parent: topLevelShell1
*form1.resizePolicy: "resize_none"
*form1.unitType: "pixels"
*form1.x: 40
*form1.y: 30
*form1.width: 440
*form1.height: 350

*menu1.class: rowColumn
*menu1.static: true
*menu1.name: menu1
*menu1.parent: form1
*menu1.rowColumnType: "menu_bar"
*menu1.menuHelpWidget: "menu1_top_b2"
*menu1.leftAttachment: "attach_form"
*menu1.rightAttachment: "attach_form"
*menu1.topAttachment: "attach_form"
*menu1.menuAccelerator: "<KeyUp>F10"

*menu1_p2.class: rowColumn
*menu1_p2.static: true
*menu1_p2.name: menu1_p2
*menu1_p2.parent: menu1
*menu1_p2.rowColumnType: "menu_pulldown"

*menu1_p2_b1.class: pushButton
*menu1_p2_b1.static: true
*menu1_p2_b1.name: menu1_p2_b1
*menu1_p2_b1.parent: menu1_p2
*menu1_p2_b1.labelString: "About"
*menu1_p2_b1.mnemonic: "A"
*menu1_p2_b1.activateCallback: {\
    popup_help_msg();\
}

*menu1_p1.class: rowColumn
*menu1_p1.static: true
*menu1_p1.name: menu1_p1
*menu1_p1.parent: menu1
*menu1_p1.rowColumnType: "menu_pulldown"

*menu1_p1_b1.class: pushButton
*menu1_p1_b1.static: true
*menu1_p1_b1.name: menu1_p1_b1
*menu1_p1_b1.parent: menu1_p1
*menu1_p1_b1.labelString: "Exit"
*menu1_p1_b1.mnemonic: "E"
*menu1_p1_b1.activateCallback: {\
    int rcode = 0;\
    rcode = kill( ( -1*pid ), 9 );\
}

*menu1_p8.class: rowColumn
*menu1_p8.static: true
*menu1_p8.name: menu1_p8
*menu1_p8.parent: menu1
*menu1_p8.rowColumnType: "menu_pulldown"

*menu1_p8_b1.class: pushButton
*menu1_p8_b1.static: true
*menu1_p8_b1.name: menu1_p8_b1
*menu1_p8_b1.parent: menu1_p8
*menu1_p8_b1.labelString: "Copy"
*menu1_p8_b1.mnemonic: "C"
*menu1_p8_b1.activateCallback: {\
#ifdef VT\
    Time timestamp1;\
\
    timestamp1 = XtLastTimestampProcessed(XtDisplay(vt1));\
     XmVtCopy (vt1, timestamp1);\
#endif\
}

*menu1_p8_b2.class: pushButton
*menu1_p8_b2.static: true
*menu1_p8_b2.name: menu1_p8_b2
*menu1_p8_b2.parent: menu1_p8
*menu1_p8_b2.labelString: "Paste"
*menu1_p8_b2.mnemonic: "P"
*menu1_p8_b2.activateCallback: {\
#ifdef VT\
    XmVtPaste (vt1);\
#endif\
}

*menu1_p3.class: rowColumn
*menu1_p3.static: true
*menu1_p3.name: menu1_p3
*menu1_p3.parent: menu1
*menu1_p3.rowColumnType: "menu_pulldown"

*menu1_p3_b5.class: cascadeButton
*menu1_p3_b5.static: true
*menu1_p3_b5.name: menu1_p3_b5
*menu1_p3_b5.parent: menu1_p3
*menu1_p3_b5.labelString: "Fonts"
*menu1_p3_b5.subMenuId: "menu1_p5"
*menu1_p3_b5.mnemonic: "F"

*menu1_p3_b6.class: cascadeButton
*menu1_p3_b6.static: true
*menu1_p3_b6.name: menu1_p3_b6
*menu1_p3_b6.parent: menu1_p3
*menu1_p3_b6.labelString: "Colors"
*menu1_p3_b6.mnemonic: "C"
*menu1_p3_b6.subMenuId: "menu1_p6"

*menu1_p3_b3.class: cascadeButton
*menu1_p3_b3.static: true
*menu1_p3_b3.name: menu1_p3_b3
*menu1_p3_b3.parent: menu1_p3
*menu1_p3_b3.labelString: "Key Mapping"
*menu1_p3_b3.mnemonic: "K"
*menu1_p3_b3.subMenuId: "menu1_p7"

*menu1_p3_b4.class: pushButton
*menu1_p3_b4.static: true
*menu1_p3_b4.name: menu1_p3_b4
*menu1_p3_b4.parent: menu1_p3
*menu1_p3_b4.labelString: "Softkeys"
*menu1_p3_b4.mnemonic: "S"
*menu1_p3_b4.activateCallback: {\
    popup_softkeyform();\
}

*menu1_p5.class: rowColumn
*menu1_p5.static: true
*menu1_p5.name: menu1_p5
*menu1_p5.parent: menu1_p3
*menu1_p5.rowColumnType: "menu_pulldown"

*menu1_p5_b1.class: pushButton
*menu1_p5_b1.static: true
*menu1_p5_b1.name: menu1_p5_b1
*menu1_p5_b1.parent: menu1_p5
*menu1_p5_b1.labelString: "Tiny"
*menu1_p5_b1.mnemonic: "T"
*menu1_p5_b1.activateCallback: {\
#ifdef VT\
XtVaSetValues( vt1, RES_CONVERT( XmNfont, "-misc-fixed-medium-*-*-*-*-50-100-100-*-*-iso8859-1" ), NULL );\
XtVaSetValues( vt1, RES_CONVERT( XmNwideFont, "-misc-fixed-medium-*-*-*-*-50-210-100-*-*-iso8859-1" ), NULL );\
XtVaSetValues( vt1, RES_CONVERT( XmNdoubleFont, "-misc-fixed-medium-*-*-*-*-50-280-200-*-*-iso8859-1" ), NULL );\
#endif\
}

*menu1_p5_b2.class: pushButton
*menu1_p5_b2.static: true
*menu1_p5_b2.name: menu1_p5_b2
*menu1_p5_b2.parent: menu1_p5
*menu1_p5_b2.labelString: "Small"
*menu1_p5_b2.mnemonic: "S"
*menu1_p5_b2.activateCallback: {\
#ifdef VT\
XtVaSetValues( vt1, RES_CONVERT( XmNfont, "-misc-fixed-medium-*-*-*-*-75-100-100-*-*-iso8859-1" ), NULL );\
XtVaSetValues( vt1, RES_CONVERT( XmNwideFont, "-misc-fixed-medium-*-*-*-*-75-200-100-*-*-iso8859-1" ), NULL );\
XtVaSetValues( vt1, RES_CONVERT( XmNdoubleFont, "-misc-fixed-medium-*-*-*-*-75-240-200-*-*-iso8859-1" ), NULL );\
#endif\
}

*menu1_p5_b3.class: pushButton
*menu1_p5_b3.static: true
*menu1_p5_b3.name: menu1_p5_b3
*menu1_p5_b3.parent: menu1_p5
*menu1_p5_b3.labelString: "Medium"
*menu1_p5_b3.mnemonic: "M"
*menu1_p5_b3.activateCallback: {\
#ifdef VT\
XtVaSetValues( vt1, RES_CONVERT( XmNfont, "-misc-fixed-medium-*-*-*-*-100-100-100-*-*-iso8859-1" ), NULL );\
XtVaSetValues( vt1, RES_CONVERT( XmNwideFont, "-misc-fixed-medium-*-*-*-*-100-200-100-*-*-iso8859-1" ), NULL );\
XtVaSetValues( vt1, RES_CONVERT( XmNdoubleFont, "-misc-fixed-medium-*-*-*-*-100-210-200-*-*-iso8859-1" ), NULL );\
#endif\
}

*menu1_p5_b4.class: pushButton
*menu1_p5_b4.static: true
*menu1_p5_b4.name: menu1_p5_b4
*menu1_p5_b4.parent: menu1_p5
*menu1_p5_b4.labelString: "Large"
*menu1_p5_b4.mnemonic: "L"
*menu1_p5_b4.activateCallback: {\
#ifdef VT\
XtVaSetValues( vt1, RES_CONVERT( XmNfont, "-misc-fixed-medium-*-*-*-*-150-100-100-*-*-iso8859-1" ), NULL );\
XtVaSetValues( vt1, RES_CONVERT( XmNwideFont, "-misc-fixed-medium-*-*-*-*-150-200-100-*-*-iso8859-1" ), NULL );\
XtVaSetValues( vt1, RES_CONVERT( XmNdoubleFont, "-misc-fixed-medium-*-*-*-*-150-200-200-*-*-iso8859-1" ), NULL );\
#endif\
}

*menu1_p5_b5.class: pushButton
*menu1_p5_b5.static: true
*menu1_p5_b5.name: menu1_p5_b5
*menu1_p5_b5.parent: menu1_p5
*menu1_p5_b5.labelString: "Extra Large"
*menu1_p5_b5.mnemonic: "E"
*menu1_p5_b5.activateCallback: {\
#ifdef VT\
XtVaSetValues( vt1, RES_CONVERT( XmNfont, "-misc-fixed-medium-*-*-*-*-200-100-100-*-*-iso8859-1" ), NULL );\
XtVaSetValues( vt1, RES_CONVERT( XmNwideFont, "-misc-fixed-medium-*-*-*-*-200-200-100-*-*-iso8859-1" ), NULL );\
XtVaSetValues( vt1, RES_CONVERT( XmNdoubleFont, "-misc-fixed-medium-*-*-*-*-200-200-200-*-*-iso8859-1" ), NULL );\
#endif\
}

*menu1_p5_b6.class: pushButton
*menu1_p5_b6.static: true
*menu1_p5_b6.name: menu1_p5_b6
*menu1_p5_b6.parent: menu1_p5
*menu1_p5_b6.labelString: "Very Large"
*menu1_p5_b6.mnemonic: "V"
*menu1_p5_b6.activateCallback: {\
#ifdef VT\
XtVaSetValues( vt1, RES_CONVERT( XmNfont, "-misc-fixed-medium-*-*-*-*-230-100-100-*-*-iso8859-1" ), NULL );\
XtVaSetValues( vt1, RES_CONVERT( XmNwideFont, "-misc-fixed-medium-*-*-*-*-230-200-100-*-*-iso8859-1" ), NULL );\
XtVaSetValues( vt1, RES_CONVERT( XmNdoubleFont, "-misc-fixed-medium-*-*-*-*-230-200-200-*-*-iso8859-1" ), NULL );\
#endif\
}

*menu1_p6.class: rowColumn
*menu1_p6.static: true
*menu1_p6.name: menu1_p6
*menu1_p6.parent: menu1_p3
*menu1_p6.rowColumnType: "menu_pulldown"

*menu1_p6_b1.class: pushButton
*menu1_p6_b1.static: true
*menu1_p6_b1.name: menu1_p6_b1
*menu1_p6_b1.parent: menu1_p6
*menu1_p6_b1.labelString: "Background Black"
*menu1_p6_b1.mnemonic: "B"
*menu1_p6_b1.activateCallback: {\
#ifdef VT\
XtVaSetValues( vt1, RES_CONVERT( XmNbackground, "Black" ), NULL );\
#endif\
}

*menu1_p6_b2.class: pushButton
*menu1_p6_b2.static: true
*menu1_p6_b2.name: menu1_p6_b2
*menu1_p6_b2.parent: menu1_p6
*menu1_p6_b2.labelString: "Foreground Green"
*menu1_p6_b2.mnemonic: "F"
*menu1_p6_b2.activateCallback: {\
#ifdef VT\
XtVaSetValues( vt1, RES_CONVERT( XmNforeground, "Green" ), NULL );\
#endif\
}

*menu1_p7.class: rowColumn
*menu1_p7.static: true
*menu1_p7.name: menu1_p7
*menu1_p7.parent: menu1_p3
*menu1_p7.rowColumnType: "menu_pulldown"

*menu1_p7_b1.class: pushButton
*menu1_p7_b1.static: true
*menu1_p7_b1.name: menu1_p7_b1
*menu1_p7_b1.parent: menu1_p7
*menu1_p7_b1.labelString: "Delete on Backspace Key"
*menu1_p7_b1.mnemonic: "D"
*menu1_p7_b1.activateCallback: {\
#ifdef VT\
XtVaSetValues( vt1, XmNdelonBSMode, True, NULL );\
#endif\
}

*menu1_p7_b2.class: pushButton
*menu1_p7_b2.static: true
*menu1_p7_b2.name: menu1_p7_b2
*menu1_p7_b2.parent: menu1_p7
*menu1_p7_b2.labelString: "Backspace on Backspace Key"
*menu1_p7_b2.mnemonic: "B"
*menu1_p7_b2.activateCallback: {\
#ifdef VT\
XtVaSetValues( vt1, XmNdelonBSMode, False, NULL );\
#endif\
}

*menu1_top_b2.class: cascadeButton
*menu1_top_b2.static: true
*menu1_top_b2.name: menu1_top_b2
*menu1_top_b2.parent: menu1
*menu1_top_b2.labelString: "Help"
*menu1_top_b2.mnemonic: "H"
*menu1_top_b2.subMenuId: "menu1_p2"

*menu1_top_b1.class: cascadeButton
*menu1_top_b1.static: true
*menu1_top_b1.name: menu1_top_b1
*menu1_top_b1.parent: menu1
*menu1_top_b1.labelString: "File"
*menu1_top_b1.mnemonic: "F"
*menu1_top_b1.subMenuId: "menu1_p1"

*menu1_top_b4.class: cascadeButton
*menu1_top_b4.static: true
*menu1_top_b4.name: menu1_top_b4
*menu1_top_b4.parent: menu1
*menu1_top_b4.labelString: "Edit"
*menu1_top_b4.mnemonic: "E"
*menu1_top_b4.subMenuId: "menu1_p8"

*menu1_top_b3.class: cascadeButton
*menu1_top_b3.static: true
*menu1_top_b3.name: menu1_top_b3
*menu1_top_b3.parent: menu1
*menu1_top_b3.labelString: "Options"
*menu1_top_b3.mnemonic: "O"
*menu1_top_b3.subMenuId: "menu1_p3"

